<?php

// You should put your code that does any post transaction tasks
// (e.g. updates the order object, sends the customer an email etc) in this function
function HandleTransactionResults($IridiumClassObject, $CallingFunction, Order $order, $order_summary) {

    $boNotify = true;
    $szNotify = null;
    $redirectto = null;
    $return = false;

    $szIntegrationMethod = $IridiumClassObject -> getIntegrationMethod();

    $transData['gateway'] = 'IridiumCorp (' . strtoupper($szIntegrationMethod) . ')';

    if ($szIntegrationMethod != IntegrationMethod::HostedPaymentForm || ($szIntegrationMethod == IntegrationMethod::HostedPaymentForm && $IridiumClassObject -> getHostedFormMethod() != HostedFormMethod::Process)) {

        $TransactionResult = $IridiumClassObject -> getTransactionResult();

        if (!$IridiumClassObject -> TransactionProcessed()) {

            $status = "Error";
            $szNotify = "Payment Processing Failed";

            $errors = $IridiumClassObject -> getErrorMessage();
            if (count($errors) > 0) {
                for ($LoopIndex = 0; $LoopIndex < count($errors); $LoopIndex++) {
                    $szNotify .= "\n- " . $errors[$LoopIndex];
                }
            } else {
                for ($LoopIndex = 0; $LoopIndex < $TransactionResult -> getErrorMessages() -> getCount(); $LoopIndex++) {
                    $szNotify .= "    - " . $TransactionResult -> getErrorMessages() -> getAt($LoopIndex);
                }

            }

        } else {

            if ($IridiumClassObject -> getIntegrationMethod() == IntegrationMethod::DirectAPI) {

                $CrossReference = $IridiumClassObject -> getTransactionOutputData() -> getCrossReference();

                if (!$GLOBALS['db'] -> misc(IridiumSQL::TableExists(IridiumSQL::tblGEP_EntryPoints))) {
                    $GLOBALS['db'] -> misc(IridiumSQL::createGEP_EntryPoints());
                } else {
                    $GLOBALS['db'] -> misc(IridiumSQL::deleteGEP_EntryPoint(10));
                }

                $GLOBALS['db'] -> misc(IridiumSQL::insertGEP_EntryPoint($IridiumClassObject -> getTransactionObject() -> getEntryPointUsed(), $IridiumClassObject -> getTransactionDateTime(), $IridiumClassObject -> getEntryPointsValidilityTimeInMinutes()));

            } else {
                $CrossReference = $TransactionResult -> getCrossReference();
            }

            switch ($TransactionResult->getStatusCode()) {
                case 0 :
                    $return = true;

                    $status = 'Approved';

                    $szNotify = "Payment Processed Successfully  =>  {$TransactionResult->getMessage()}";

                    break;
                case 3 :
                    $status = "Pending";
                    $szNotify = "3D Secure Authentication Required";

                    $Is3DSecureEnrolled = TRUE;

                    //IridiumDatabaseEXT::insert3DS_Transaction($CrossReference, $UserID, $IridiumClassObject->getTransactionCurrencyISOCode(), $IridiumClassObject->getAmountDecimalised());
                    ## Display 3D-Secure screen
                    $GLOBALS['smarty'] -> assign('DISPLAY_3DS', true);
                    $GLOBALS['session'] -> set('DISPLAY_3DS', true);
                    $GLOBALS['session'] -> set('ACSUrl', $IridiumClassObject -> getTransactionOutputData() -> getThreeDSecureOutputData() -> getACSURL(), 'iridiumcorp');
                    $GLOBALS['session'] -> set('PaREQ', $IridiumClassObject -> getTransactionOutputData() -> getThreeDSecureOutputData() -> getPaREQ(), 'iridiumcorp');

                    $GLOBALS['session'] -> set('TermUrl', $GLOBALS['storeURL'] . '/index.php?_g=rm&type=gateway&cmd=call&module=IridiumCorp&mode=3ds', 'iridiumcorp');
                    $GLOBALS['session'] -> set('CrossReference', $CrossReference, 'iridiumcorp');
                    $GLOBALS['session'] -> set('UserID', $order_summary['customer_id'], 'iridiumcorp');

                    $GLOBALS['session'] -> set('CurrencyISOCode', $IridiumClassObject -> getTransactionCurrencyISOCode(), 'iridiumcorp');
                    $GLOBALS['session'] -> set('AmountDecimalised', $IridiumClassObject -> getAmountDecimalised(), 'iridiumcorp');

                    ## Check for custom template for module in skin folder
                    $file_name = 'form.tpl';
                    $form_file = $GLOBALS['gui'] -> getCustomModuleSkin('gateway', dirname(dirname(__FILE__)), $file_name);
                    $GLOBALS['gui'] -> changeTemplateDir($form_file);
                    $return = $GLOBALS['smarty'] -> fetch($file_name);
                    $GLOBALS['gui'] -> changeTemplateDir();

                    break;
                case 5 :
                    $status = 'Declined';
                    $szNotify = "Payment Processing Failed  =>  {$TransactionResult->getMessage()}";

                    break;
                case 20 :
                    if ($TransactionResult -> getPreviousTransactionResult() -> getStatusCode() -> getValue() == 0) {

                        $return = TRUE;

                        $status = "Approved";

                        $szNotify = "Payment Processed Successfully  =>  {$TransactionResult->getMessage()}";
                    } else {

                        $status = 'Error';

                        $szNotify = "Payment Processing Failed  =>  {$TransactionResult->getMessage()}";
                    }
                    break;
                case 30 :
                    $status = 'Error';
                    $szNotify = "Payment Processing Failed  =>  Unknown Error";

                    if ($TransactionResult -> getErrorMessages() -> getCount() > 0) {

                        for ($LoopIndex = 0; $LoopIndex < $TransactionResult -> getErrorMessages() -> getCount(); $LoopIndex++) {
                            $szNotify .= "  - " . $TransactionResult -> getErrorMessages() -> getAt($LoopIndex);
                        }
                    }

                    break;
                default :
                    $status = 'Error';

                    $szNotify = "Payment Processing Failed  =>  Unknown Error";
                    if ($TransactionResult -> getErrorMessages() -> getCount() > 0) {

                        for ($LoopIndex = 0; $LoopIndex < $TransactionResult -> getErrorMessages() -> getCount(); $LoopIndex++) {
                            $szNotify .= "  - " . $TransactionResult -> getErrorMessages() -> getAt($LoopIndex);
                        }
                    }

                    break;
            }
        }

        $transData['status'] = $status;
        $transData['notes'] = $szNotify;
        $transData['trans_id'] = $CrossReference;
        $transData['order_id'] = $IridiumClassObject->getOrderID(); //$order_summary['cart_order_id'];
        // $this -> _basket['cart_order_id'];
        $transData['amount'] = $IridiumClassObject -> getAmountDecimalised();
        $transData['customer_id'] = $order_summary['customer_id'];
        $transData['extra'] = '';
        $order -> logTransaction($transData);

        $redirect_to = null;

        switch ($status) {
            case "Approved" :
                $order -> orderStatus(Order::ORDER_PROCESS, $transData['order_id']);
                $order -> paymentStatus(Order::PAYMENT_SUCCESS, $transData['order_id']);

                //$redirect_to = '?_a=vieworder&cart_order_id=' . $transData[order_id];
                $redirect_to = 'complete';

                $GLOBALS['gui'] -> setNotify($szNotify);

                break;

            case "Declined" :
                $order -> orderStatus(Order::ORDER_PROCESS, $transData['order_id']);
                $order -> paymentStatus(Order::PAYMENT_DECLINE, $transData['order_id']);

                $redirect_to = 'gateway';
                $GLOBALS['gui'] -> setError($szNotify);

                break;

            case "Pending" :
                $order -> orderStatus(Order:: ORDER_PENDING, $transData['order_id']);
                $order -> paymentStatus(Order::PAYMENT_PENDING, $transData['order_id']);
                break;
            default :
                $order -> orderStatus(Order::ORDER_PROCESS, $transData['order_id']);
                $order -> paymentStatus(Order::PAYMENT_PROCESS, $transData['order_id']);

                $redirect_to = 'gateway';
                $GLOBALS['gui'] -> setError($szNotify);

                break;
        }

    } else {

    }

    if ($redirect_to == null) {
        return $return;
    } else {

        $redirect_to = currentPage(array('_g', 'type', 'cmd', 'module'), array('_a' => $redirect_to));
        $GLOBALS['session'] -> delete('', 'IridiumCorp');

        if ($CallingFunction != "3DSecureCallback") {
            httpredir($redirect_to);
        } elseif ($CallingFunction == "3DSecureCallback") {
            echo sprintf('<script type="text/javascript">self.parent.location=\'%s\'</script>', $redirect_to);
            echo sprintf('<noscript><a href="%s" target="_parent">Please click to continue</a></noscript>', $redirect_to);
        }
    }

    return $return;
}
?>
